<template>
  <div class="v-container-principal">
    <p class="text-h4 mb-10">
      Mis citas agendadas
    </p>
    <v-row>
      <v-col cols="6" md="4" class="pb-0">
        <div>FECHA INICIO:</div>
        <date-picker
          key="1"
          class="px-0 pb-0"
          :change-function="(date) => selectedDate({ date, type: 'start' })"
        />
      </v-col>
      <v-col cols="6" md="4" class="pb-0">
        <div>FECHA FIN:</div>
        <date-picker
          key="2"
          class="px-0 pb-0"
          :change-function="(date) => selectedDate({ date, type: 'end' })"
        />
      </v-col>
    </v-row>
    <v-row v-if="loading" justify="center" no-gutters>
      <v-progress-circular
        :size="100"
        color="primary"
        indeterminate
      />
    </v-row>
    <v-row v-else>
      <v-col md="12">
        <div class="text-uppercase mb-4" v-html="amount" />
        <v-divider />
        <div
          v-for="(appointment, index) in appointments"
          :key="index"
        >
          <v-row
            v-if="validateNewDate(index)"
            no-gutters
            justify="start"
          >
            <v-col md="4">
              <h2 class="subtitle-1 font-weight-black">
                {{ formatDate(appointment.startTime) }}
              </h2>
            </v-col>
          </v-row>
          <DetailSpecialistCard
            :key="index"
            :appointment="appointment"
            :id-appointment="appointment.idAppointment"
          />
        </div>
      </v-col>
    </v-row>
  </div>
</template>

<script>
import { mapActions, mapGetters, mapState } from 'vuex';
import moment from 'moment-timezone';
import DatePicker from '~/components/DatePickers/DatePickerAll.vue';
import DetailSpecialistCard from '~/components/appointment/DetailSpecialistCard';

export default {
  name: 'Index',
  components: {
    DetailSpecialistCard,
    'date-picker': DatePicker,
  },
  data: () => ({
    date: moment().tz('America/Lima').format().slice(0, 10),
    iniDate: moment().tz('America/Lima').format().slice(0, 10),
    endDate: moment().tz('America/Lima').format().slice(0, 10),
    menu: false,
    currentDay: true,
    modal: false,
    loading: false,
    appointmen: [
      {
        idAppointment: 1,
        specialistName: 'marco',
        specialistFatherLastname: 'Quezada',
        specialistMotherLastname: 'Aquino',
        profileImageUrl: '',
        appointmentStartTime: new Date(),
        appointmentEndTime: new Date(),
      },
      {
        idAppointment: 7,
        specialistName: 'Juan',
        specialistFatherLastname: 'Flores',
        specialistMotherLastname: 'Arq',
        profileImageUrl: '',
        appointmentStartTime: new Date(),
        appointmentEndTime: new Date(),
      },
    ],
  }),
  mounted() {
    this.getAllAppointments();
  },
  computed: {
    ...mapState({
      appointments: state => state.patient.patient.appointments,
    }),
    ...mapGetters({
      myUserUuid: 'auth/myUserUuid',
    }),
    amount() {
      const length = this.appointments.length;
      const sufix = length > 1 ? 'citas programadas' : 'cita programada';
      if (length === 0) {
        return 'No hay citas registradas';
      } else {
        return `Hay ${length} ${sufix}`;
      }
    },
  },
  methods: {
    validateNewDate(index) {
      if (index === 0) {
        return true;
      } else {
        console.log('DATE', this.appointments[index].startTime);
        const currentDate = this.appointments[index].startTime.split('T');
        const dayBefore = this.appointments[index - 1].startTime.split('T');
        console.log('CURRENTDAY', currentDate[0]);
        console.log('DAYBEFORE', dayBefore[0]);
        if (currentDate[0] !== dayBefore[0]) {
          return true;
        } else {
          return false;
        }
      }
    },
    getAllAppointments() {
      this.getAppointments({ dateIni: this.iniDate, dateEnd: this.endDate, patientUuid: this.myUserUuid });
    },
    goToSession(idSession) {
      this.$router.push(`/paciente/sesion/${idSession}`);
    },
    ...mapActions({
      getAppointments: 'patient/patient/getAppointments',
    }),
    async selectedDate(value) {
      this.loading = true;
      if (value.type === 'start') {
        console.log('modifica inciio');
        await this.getAppointments({
          dateIni: value.date,
          dateEnd: this.endDate,
          patientUuid: this.myUserUuid,
        });
        this.iniDate = value.date;
      } else {
        console.log('modifica finn');
        await this.getAppointments({
          dateIni: this.iniDate,
          dateEnd: value.date,
          patientUuid: this.myUserUuid,
        });
        this.endDate = value.date;
      }
      this.loading = false;
    },
    formatDate(date) {
      if (!date) { return null; }

      const [year, month, day] = date.split('-');
      const months = ['enero', 'febrero', 'marzo', 'abril', 'mayo', 'junio', 'julio', 'agosto',
        'setiembre', 'octubre', 'noviembre', 'diciembre'];
      const [dayNumber] = day.split('T');
      return `${dayNumber} de ${months[month - 1]} del ${year}`;
    },
  },
};
</script>

<style scoped>
</style>
